#!/bin/sh
#
###############################################################################
#
# kpeexp.sh, Version 1.2
# Get paths from texmf.cnf
# Copyright (C) 1995 Frank Langbein
#
# Usage: 
#     kpseexp.sh [-sed sedpath] [-grep greppath] [-texmfcnf texmfcnfpath]
#                [-help] [-expand var] 
#                 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
###############################################################################
#

TEXMFCNFPATH="/etc:/usr/etc:/usr/local/etc:/usr/lib/texmf/web2c:/usr/local/lib/texmf/web2c"
ACTION="help"
SED="sed"
GREP="grep"
OPT=""
for o in $*
do
  if [ -z "$OPT" ]; then
    case "$o" in 
           "-sed") OPT="SED" ;;
          "-grep") OPT="GREP" ;;
      "-texmfcnf") OPT="TEXMF_CNF" ;;
        "-expand") ACTION="expand"
                   OPT="EXPVAR" ;;
          "-help") ACTION="help" 
                   OPT="" ;;
                *) ACTION="help"
                   OPT="" 
                   break ;;
    esac
  else
    eval "$OPT"=\'"$o"\'
    OPT=""
  fi
done

case "$ACTION" in
  "expand") for p in "$SED" "$GREP" "cut"
            do
              if [ ! -x "$p" -a ! -x "`${WHICH:-which} "$p"`" ]; then
                echo "`basename $0`: $p not found" 1>&2
                exit 1
              fi
            done
            if [ "`echo "$EXPVAR" | cut -c1`" != '$' ]; then
              echo "$EXPVAR"
            else
              EXPVAR="`echo "$EXPVAR" | cut -c2-`"
              if [ "$TEXMF_CNF" = "" ]; then
                for d in `echo "$TEXMFCNFPATH" | "$SED" -e"s,:, ,g"`
                do
                  if [ -r "$d/texmf.cnf" ]; then
                    TEXMF_CNF="$d/texmf.cnf"
                    break
                  fi
                done
              fi
              if [ -r "$TEXMF_CNF" ]; then
                TEXMF_DIR=`"$GREP" "^TEXMF = " "$TEXMF_CNF" | cut -d"=" -f2 \
                  | "$SED" -e "s,^ *,,"`
                if [ "$EXPVAR" != "TEXMF" ]; then
                  "$GREP" "^$EXPVAR = " "$TEXMF_CNF" | cut -d"=" -f2 \
                    | "$SED" -e "s,^ *,," -e "s,\$TEXMF,$TEXMF_DIR,g"
                else
                  echo $TEXMF_DIR
                fi
              else
                echo "`basename $0`: texmf.cnf not found in $TEXMFCNFPATH" 1>&2
                exit 1
              fi
            fi ;;
         *) echo "Usage: `basename $0` [-sed sedpath] [-grep greppath] [-texmfcnf texmfcnfpath]" 1>&2
            echo "         [-help] [-expand var]" 1>&2 ;;
esac
exit 0
