# Displaying in terminal window

proc focusLog {} {
  global params
  
  set old_focus [focus]
  if {$params(ShowOut)} {
   raise .t 
  } else {
    wm deiconify .t
  }
  .t.text mark set insert end
  .t.text insert insert \n
  .t.text mark set pos insert
  .t.text insert insert "---Press-Q-to-Quit---\n"
  .t.text yview -pickplace pos
  set params(log_end) ""
  xfocus .t.text 
  bind .t.text <Down> {
    %W mark set insert "insert + 1 l"
    %W yview -pickplace insert
  }
  bind .t.text <Up> {
    %W mark set insert "insert - 1 l"
    %W yview -pickplace insert
  }
  bind .t.text <Next> {
    %W mark set insert "insert + 15 l"
    %W yview -pickplace insert
  }
  bind .t.text <Prior> {
    %W mark set insert "insert - 15 l"
    %W yview -pickplace insert
  }
  bind .t.text <Any-Key> {
    %W insert insert "\n QUIT "
    %W yview -pickplace insert
    set params(log_end) end
  }
  tkwait variable params(log_end)
  bind .t.text <Any-Key> { }
  .t.text mark set insert end
  xfocus $old_focus
  update idletasks
  if {!$params(ShowOut)} {
    wm withdraw .t
  }
}

proc catfile {file} {
  global params
  
  set old_focus [focus]
  if {$params(ShowOut)} {
   raise .t 
  } else {
    wm deiconify .t
  }
  .t.text mark set insert end
  .t.text insert insert \n
  set pos [.t.text index insert]
  .t.text insert insert \
  "--- $file -------------------------------------\n"
  if {[catch {set fd [open $file r]} msg]} {
    OutMsg $msg
    return
  }
  while {![eof $fd]} {
    if {[gets $fd s] != -1} {
      .t.text insert insert $s\n
    }
  }
  .t.text insert insert "---End-of-file---Press-Q-to-Quit---\n"
  close $fd
  set params(log_end) ""
  .t.text mark set insert $pos
  .t.text yview insert
  xfocus .t.text 
  bind .t.text <Down> {
    %W mark set insert "insert + 1 l"
    %W yview -pickplace insert
  }
  bind .t.text <Up> {
    %W mark set insert "insert - 1 l"
    %W yview -pickplace insert
  }
  bind .t.text <Next> {
    %W mark set insert "insert + 15 l"
    %W yview -pickplace insert
  }
  bind .t.text <Prior> {
    %W mark set insert "insert - 15 l"
    %W yview -pickplace insert
  }
  bind .t.text <Any-Key> {
    switch -regexp -- "%A" {
      \003 {
        %W insert insert "\n INT "
        %W yview -pickplace insert
        set cmd(end) end
      }
      \004 {
        %W mark set insert end
        %W insert insert "\n EOF "
        %W yview -pickplace insert
        set params(log_end) end
      }
      \r {
        %W mark set insert "insert + 1 lines"
        %W yview -pickplace insert
      }
      [qQ] {
        %W insert insert "\n QUIT "
        %W yview -pickplace insert
        set params(log_end) end
      }
    }
  }
  tkwait variable params(log_end)
  bind .t.text <Any-Key> { }
  .t.text mark set insert end
  xfocus $old_focus
  update idletasks
  if {!$params(ShowOut)} {
    wm withdraw .t
  }
}
