# help.tcl
#
# Syntax of help files:
# %.index
# %/topic
# %/topic
# ...
# Text
# 
proc cindex {s i} {
  return [string range $s $i $i]
}

proc ref_find {widget item} {
  global hlp

  if {[set i [lsearch $hlp(ref_list) "$item*"]] >= 0} {
    set pos [lindex [lindex $hlp(ref_list) $i] 1]
    debug "$item : $pos"
    $widget config -state normal
    eval readhelp $widget $pos
    $widget config -state disabled
  }
}

proc ref_tell {filelist} {
  global hlp
  
#  set hlp(ref_list) {}
  set hlp(idx_list) {}
  set fref [open $hlp(dir)/help.ref w]
  set fidx [open $hlp(dir)/help.idx w]
  set idx ""
  set head ""
  foreach f $filelist {
    set fd [open $f r]
    set fhead 0
    while {! [eof $fd]} {
      set pos [tell $fd]
      gets $fd s
      if [regexp {^%\.(.*)>(.*)} $s match idx head] {
        lappend hlp(idx_list) "$head\xff$idx"
#        puts $fidx "$head\xff$idx"
        set fhead 1
      } elseif [string match "%/*" $s] {
        lappend hlp(idx_list) "[string range $s 2 end] -> $head\xff$idx"
#        puts $fidx "[string range $s 2 end] -> $head\xff$idx"
      } elseif $fhead {
#        lappend hlp(ref_list) [list $idx [list $f $pos]]
        puts $fref [list $idx [list $f $pos]]
        set fhead 0
      }
    }
    close $fd
  }
  set hlp(idx_list) [lsort $hlp(idx_list)]
  foreach l $hlp(idx_list) {
    puts $fidx $l
  }
  close $fref
  close $fidx
}

puts [glob -nocomplain $hlp(dir)/*.hlp] 
ref_tell [glob -nocomplain $hlp(dir)/*.hlp] 
